Page MenuHomePhabricator

Error situations (wrong file format, abuse filter failure...) lead to an error page
Closed, ResolvedPublic3 Story Points

Description

Problem:
There might be an error during the attempt to upload the file to commons so that the user cannot be forwarded to the special page.
The list of errors can be found in T189570: Show meaningful error messages if import fails

Task:
Show a warning on an error page on the target wiki with a note on what went wrong.

New Page:


with a link back to the source wiki

v3 Acceptance Criteria

  • There is an error page that non-media wiki core errors can be routed to.
  • The error page should appear for all errors that cannot be resolved from within the FileImporter.
  • All errors that can be detected even before hitting the import button immediately lead to that error page
  • Errors that occur after hitting the import button (such as abusefilter rule failures) also lead to that error page
  • The link on the error page points to the source wiki's file location
  • The error messages displayed correspond to the error that occured.
  • In T189570: Show meaningful error messages if import fails for all errors, we can see the current state of what happens right now, so that we can create follow up tickets for full "correct error page handling"

Event Timeline

Hanna_Petruschat_WMDE triaged this task as Normal priority.Mar 12 2018, 8:37 AM
Hanna_Petruschat_WMDE created this task.
Lea_WMDE updated the task description. (Show Details)Mar 13 2018, 3:27 PM
Lea_WMDE set the point value for this task to 5.
Lea_WMDE updated the task description. (Show Details)Mar 13 2018, 3:35 PM

I updated the Mock in the task description to the current version. Please be aware to change the text in the red message box regarding the error messages collected in T189570.

Change 426916 had a related patch set uploaded (by Andrew-WMDE; owner: Andrew-WMDE):
[mediawiki/extensions/FileImporter@master] Add an error page

https://gerrit.wikimedia.org/r/426916

Tobi_WMDE_SW changed the point value for this task from 5 to 3.Apr 17 2018, 2:56 PM
Tobi_WMDE_SW added a subscriber: Tobi_WMDE_SW.

Remaining work to do:
find out which error messages are handled by core and deal with them

Andrew-WMDE updated the task description. (Show Details)Apr 17 2018, 3:00 PM
Andrew-WMDE updated the task description. (Show Details)Apr 17 2018, 3:03 PM

I did a full analysis of error cases that already exist in MediaWiki core in T189570#4139876.

WMDE-Fisch added a subscriber: Andrew-WMDE.

The current version of the patch only catches the errors thrown by our own interface and redirect them to the new error page as stated in the ticket. Checking all the cases and redirecting more error should be handled individually when dealing with the full list in T189570

Problems that occur after hitting the import button (such as abusefilter rule failures) also lead to that error page

Currently abuse filter errors lead back to the import preview page, because the reasons for them could ( sometimes ) be fixed there or they just meant to trigger a warning and the user can do the edit anyway. Should we have an extra error page with the option to go back importing then? @Lea_WMDE

@WMDE-Fisch would it be possible to send back to the import preview page for warnings and fixable situations, and to show the error page if this is a real blocker?

@WMDE-Fisch would it be possible to send back to the import preview page for warnings and fixable situations, and to show the error page if this is a real blocker?

That's what we are doing now. And it looks like that for the AbuseFilter ( back to preview ):

And for the TitleBlacklist: ( "stay" on the title change page ):

The text is generated by the extensions themselves. We just might want to reconsider styling here...

Lea_WMDE updated the task description. (Show Details)May 2 2018, 10:09 AM

As discussed just now: We usually want to display solveable errors in the location where they can be solved. The error page is for the cases that cannot be solved. This is also why the box is red. Yellow boxes indicate "this is blocking you now, but you can solve it!"

Change 426916 merged by jenkins-bot:
[mediawiki/extensions/FileImporter@master] Add a custom error page for unified error handling

https://gerrit.wikimedia.org/r/426916

Thanks for the test cases! Am I right to assume that all the cases that have links are the ones that we produce, whereas all error cases of T189570 that don't have a linked example are the ones that are mediawiki core errors and thus not handled by this patch?

One thing, that did not work for me:
file format not accepted currently leads you to the change the title page, and then you don't get away from there.

WMDE-Fisch added a comment.EditedMay 3 2018, 2:13 PM

Thanks for the test cases! Am I right to assume that all the cases that have links are the ones that we produce, whereas all error cases of T189570 that don't have a linked example are the ones that are mediawiki core errors and thus not handled by this patch?

Hmm kind of. :-) At least for me this ticket was mainly about introducing the error page in general, use it on all errors we already handle gracefully and that are at the same time issues we want deal with. Yes for most of these issues we have an example now on the other ticket. ( I have non for revision history is somewhat broken. No idea where that came from again.

One thing, that did not work for me:
file format not accepted currently leads you to the change the title page, and then you don't get away from there.

For the error with wrong file format we have T193229. I would put that ticket extra, because never seemed to have dealt with that correctly.

Hmm kind of. :-) At least for me this ticket was mainly about introducing the error page in general, use it on all errors we already handle gracefully and that are at the same time issues we want deal with. Yes for most of these issues we have an example now on the other ticket.

Oh boy, learning for next time: We need to make sure acceptance criteria always represent exactly what is planned, even if plans change in the mean time.
For now: I can see two ways of not leaving this with a bit of a mess. A) We go and add all applicable errors to the error page, or B) you add to the overview ticket another column with the state for each of the errors (i.e.: "Is handled by media wiki error message", "Should be handled by us", "Is handled by us with wrong error message", "Is handled by us exactly the way described here", "Has its own ticket"). What do you think?

( I have non for revision history is somewhat broken. No idea where that came from again.

This came from T179645: FileImporter, importing https://commons.wikimedia.org/wiki/File:30th_Street_at_5th_Avenue_-_Stra%C3%9Fe_in_New_York.jpg fails, I'll add the example now.

... and I realize that I can start with writing the state for all the examples I saw so far, I would need help with the other ones, though

(moved this back to review to make more clear that we still need info on the error messages where I could not give info about the current state in T189570: Show meaningful error messages if import fails )

WMDE-Fisch removed WMDE-Fisch as the assignee of this task.Aug 30 2018, 11:39 AM
WMDE-Fisch added a subscriber: WMDE-Fisch.
WMDE-Fisch closed this task as Resolved.Mar 26 2019, 2:12 PM
WMDE-Fisch claimed this task.

Everything else tracked in T189570